<?php
/**
* Glossary 
* @package project
* @author Wizard <sergejey@gmail.com>
* @copyright http://majordomo.smartliving.ru/ (c)
* @version 0.1 (wizard, 23:11:03 [Nov 24, 2018])
*/
//
//
class app_glossary extends module {
/**
* app_glossary
*
* Module class constructor
*
* @access private
*/
function __construct() {
  $this->name="app_glossary";
  $this->title="Glossary";
  $this->module_category="<#LANG_SECTION_APPLICATIONS#>";
  $this->checkInstalled();
}
/**
* saveParams
*
* Saving module parameters
*
* @access public
*/
function saveParams($data=1) {
 $p=array();
 if (IsSet($this->id)) {
  $p["id"]=$this->id;
 }
 if (IsSet($this->view_mode)) {
  $p["view_mode"]=$this->view_mode;
 }
 if (IsSet($this->edit_mode)) {
  $p["edit_mode"]=$this->edit_mode;
 }
 if (IsSet($this->tab)) {
  $p["tab"]=$this->tab;
 }
 return parent::saveParams($p);
}
/**
* getParams
*
* Getting module parameters from query string
*
* @access public
*/
function getParams() {
  global $id;
  global $mode;
  global $view_mode;
  global $edit_mode;
  global $tab;
  if (isset($id)) {
   $this->id=$id;
  }
  if (isset($mode)) {
   $this->mode=$mode;
  }
  if (isset($view_mode)) {
   $this->view_mode=$view_mode;
  }
  if (isset($edit_mode)) {
   $this->edit_mode=$edit_mode;
  }
  if (isset($tab)) {
   $this->tab=$tab;
  }
}
/**
* Run
*
* Description
*
* @access public
*/
function run() {
 global $session;
  $out=array();
  if ($this->action=='admin') {
   $this->admin($out);
  } else {
   $this->usual($out);
  }
  if (IsSet($this->owner->action)) {
   $out['PARENT_ACTION']=$this->owner->action;
  }
  if (IsSet($this->owner->name)) {
   $out['PARENT_NAME']=$this->owner->name;
  }
  $out['VIEW_MODE']=$this->view_mode;
  $out['EDIT_MODE']=$this->edit_mode;
  $out['MODE']=$this->mode;
  $out['ACTION']=$this->action;
  $out['TAB']=$this->tab;
  $this->data=$out;
  $p=new parser(DIR_TEMPLATES.$this->name."/".$this->name.".html", $this->data, $this);
  $this->result=$p->result;
}
/**
* BackEnd
*
* Module backend
*
* @access public
*/
function admin(&$out) {
 if (isset($this->data_source) && !$_GET['data_source'] && !$_POST['data_source']) {
  $out['SET_DATASOURCE']=1;
 }
 if ($this->data_source=='app_glossary' || $this->data_source=='') {
  if ($this->view_mode=='' || $this->view_mode=='search_app_glossary') {
   $this->search_app_glossary($out);
  }
  if ($this->view_mode=='edit_app_glossary') {
   $this->edit_app_glossary($out, $this->id);
  }
  if ($this->view_mode=='delete_app_glossary') {
   $this->delete_app_glossary($this->id);
   $this->redirect("?");
  }
 }
}
/**
* FrontEnd
*
* Module frontend
*
* @access public
*/
function usual(&$out) {
 $this->admin($out);
}
/**
* app_glossary search
*
* @access public
*/
 function search_app_glossary(&$out) {
  require(DIR_MODULES.$this->name.'/app_glossary_search.inc.php');
 }
/**
* app_glossary edit/add
*
* @access public
*/
 function edit_app_glossary(&$out, $id) {
  require(DIR_MODULES.$this->name.'/app_glossary_edit.inc.php');
 }
/**
* app_glossary delete record
*
* @access public
*/
 function delete_app_glossary($id) {
  $rec=SQLSelectOne("SELECT * FROM app_glossary WHERE ID='$id'");
  // some action for related tables
  SQLExec("DELETE FROM app_glossary WHERE ID='".$rec['ID']."'");
 }
 function propertySetHandle($object, $property, $value) {
   $table='app_glossary';
   $properties=SQLSelect("SELECT ID FROM $table WHERE LINKED_OBJECT LIKE '".DBSafe($object)."' AND LINKED_PROPERTY LIKE '".DBSafe($property)."'");
   $total=count($properties);
   if ($total) {
    for($i=0;$i<$total;$i++) {
     //to-do
    }
   }
 }
/**
* Install
*
* Module installation routine
*
* @access private
*/
 function install($data='') {
  parent::install();
 }
/**
* Uninstall
*
* Module uninstall routine
*
* @access public
*/
 function uninstall() {
  SQLExec('DROP TABLE IF EXISTS app_glossary');
  parent::uninstall();
 }
/**
* dbInstall
*
* Database installation routine
*
* @access private
*/
 function dbInstall($data) {
/*
app_glossary - 
*/
  $data = <<<EOD
 app_glossary: ID int(10) unsigned NOT NULL auto_increment
 app_glossary: TITLE varchar(100) NOT NULL DEFAULT ''
 app_glossary: DESCRITION varchar(255) NOT NULL DEFAULT ''
 app_glossary: LINKED_OBJECT varchar(100) NOT NULL DEFAULT ''
 app_glossary: LINKED_PROPERTY varchar(100) NOT NULL DEFAULT ''
 app_glossary: LINKED_METHOD varchar(100) NOT NULL DEFAULT ''
EOD;
  parent::dbInstall($data);
 }
// --------------------------------------------------------------------
}
/*
*
* TW9kdWxlIGNyZWF0ZWQgTm92IDI0LCAyMDE4IHVzaW5nIFNlcmdlIEouIHdpemFyZCAoQWN0aXZlVW5pdCBJbmMgd3d3LmFjdGl2ZXVuaXQuY29tKQ==
*
*/
